#include "contours.h"
#include "reconst.h"
#include <math.h>
#include <stdio.h>
#include <iostream>
#include "cv.h"
#include "opencv2/core/core.hpp"
#include "opencv2/features2d.hpp"
#include "opencv2/highgui/highgui.hpp"
#include "opencv2/calib3d/calib3d.hpp"
#include "opencv2/imgproc/imgproc.hpp"
#include "opencv2/video/tracking.hpp"
#include "opencv2/highgui/highgui.hpp"
#include "opencv2/calib3d/calib3d.hpp"
#include "opencv2/nonfree/features2d.hpp"
#include "opencv2/imgproc/imgproc.hpp"
#include "opencv2\shape\shape_distance.hpp"
#include "opencv2\imgproc\imgproc_c.h"

extern "C"{
	#include "shapelib-1.3.0\shapefil.h"
}

IplImage* g_image = NULL;
IplImage* g_gray = NULL;
int g_thresh = 100;
CvMemStorage* g_storage = NULL;

#include "stdafx.h"
#include <math.h>
using namespace cv;
using namespace std;
//using namespace std;
IplImage* gray = 0;
IplImage* bin = 0;
IplImage* dst= 0;
Mat src; Mat src_gray;
int thresh = 100;
int max_thresh = 255;
RNG rng(12345);
Mat drawing;
IplImage * draw; 

int n;
std::vector<int> g[6500];
bool used[6500];
vector<int> comp;



vector<vector< Point>> getContour(Mat src, int thresh){
  Mat canny_output;
  Mat src_gray;
  vector<vector<Point>> contours;
  vector<Vec4i> hierarchy;
  cvtColor( src, src_gray, CV_BGR2GRAY );
  blur( src_gray, src_gray, Size(3,3) );
  /// Detect edges using canny
  Canny( src_gray, canny_output, thresh, thresh*2, 3 );
  
  /// Find contours
  //canny_output = cvCreateImage( CvSize(src.size()), IPL_DEPTH_8U, 1 );
  findContours( canny_output, contours, hierarchy, CV_RETR_EXTERNAL, CV_CHAIN_APPROX_SIMPLE, Point(0, 0) );
  /// Draw contours
  
  /// Find the convex hull object for each contour
 vector<Point> merged_contour_points;
 vector<Point> hull( contours.size() );
 drawing = Mat::zeros( canny_output.size(), CV_8UC3 );
 const int temp = contours.size();
 vector<vector<int>> graph = vector<vector<int>>(); 
 vector<vector<Point>> t = vector<vector<Point>>();
	for(int i = 0; i< contours.size(); i++)
			 {
				if (contours[i].size() > 100
					){
					t.push_back(contours[i]);
					 for(int j = 0; j < contours[i].size(); ++j){
						 merged_contour_points.push_back(contours[i][j]);
					}
				Scalar color = Scalar( rng.uniform(0, 255), rng.uniform(0,255), rng.uniform(0,255) );
				drawContours( drawing, contours, i, color, 2, 8, hierarchy, 0, Point() );
			//drawContours( drawing, hull, i, color, 1, 8, vector<Vec4i>(), 0, Point() );
		}
     }
	cv::convexHull(cv::Mat(merged_contour_points),hull);
    Ptr <HausdorffDistanceExtractor> haus = createHausdorffDistanceExtractor();
	contours.push_back(hull);
    Scalar color = Scalar( rng.uniform(0, 255), rng.uniform(0,255), rng.uniform(0,255) );
    drawContours( drawing, contours, contours.size()-1, color, 2, 8, hierarchy, 0, Point() );
	   
    contours = t;
 /*   for (int i = 0; i < contours.size(); ++i){
		graph.push_back(vector<int>());
		for(int j = 0; j < contours.size(); ++j){
			graph[i].push_back(haus->computeDistance(contours[i], contours[j]));
		}
	}
  */
  /// Show in a window
  vector<vector<Point>> hullContour = vector<vector<Point>>();
  hullContour.push_back(hull);
  imshow("contour",drawing);
 // waitKey(0);
  return hullContour;

}


 double * getMax (vector<vector<double>> a){
	double max = a[0][0];
	int x = 0;
	int y = 0;
	for(int i =0; i < a.size(); ++i){
		for(int j = 0; j < a[i].size(); ++j){
			if (a[i][j] > max){
				max = a[i][j];
				x = i;
				y = j;
			}
		}
	}
	double res[3] = {x,y,max};
	return res;
}

void getContoursimage (Mat src, Mat src2){

  vector<vector<Point>> contour1 = getContour(src, 100);
  vector<vector<Point>> contour2 = getContour(src2, 100);
  Moments moments1 = moments(contour1[0],false);
  Moments moments2 = moments(contour2[0],false);

  
    
  int stop = 1;
//  getValuesContour(contour1[0]);
  vector<vector<double>> temp = vector<vector<double>>();
  for(int i = 0; i < contour1.size(); ++i){
	  temp.push_back(vector<double>());
	  for(int j = 0; j < contour2.size(); ++j){
		  temp[i].push_back(matchShapes(contour1[i],contour2[j], CV_CONTOURS_MATCH_I2,1));	
		  printf("%f \n",matchShapes(contour1[i],contour2[j], CV_CONTOURS_MATCH_I2,1));
	  }
  }
//  safeContour(contour1);

  /*
  vector<vector<double>> samecontour = vector<vector<double>>(contour1.size()); 
  int temp2 = min(contour1.size(), contour2.size());
  for(int i =0; i < temp2; ++i){	
	double* res = getMax(temp);
	double k = res[0];
	double l = res[1];
	double q = res[2];
	samecontour[i].push_back(k);
	samecontour[i].push_back(l);
	samecontour[i].push_back(q);
	for(int j = 0; j < temp.size(); ++j){
		temp[j][l] = 0;
	}
	for(int j = 0; j < temp[k].size(); ++j){
	  temp[k][j] = 0;
	}	
  }
 // reconst(6, Point(0,0), Point(0,0));
  reconst3(contour1,contour2,samecontour);
  */
  

    
   
  /// Convert image to gray and blur it
  
  /// Create Window
 // char* source_window = "Source";
 // namedWindow( source_window, CV_WINDOW_NORMAL );
//  imshow( source_window, src );
 // waitKey(0);
}



void safeShape(){

  int count = 0;
  double * padfX = new double[1];
  double * padfY = new double[1];
  int * panPartStart = new int[1];
  panPartStart[0] = 1;
  padfX[0] = 100.32;
  //padfX[1] = 250000;
  //padfX[2] = 200000;
 // padfX[3] = 100000;
 // padfX[4] = 50000;
  padfY[0] = 700.54;
 // padfY[1] = 6500000;
 // padfY[2] = 6000000;
 // padfY[3] = 7000000;
 // padfY[4] = 30;
  
  int count2 = 0;
  double * padfX2 = new double[5];
  double * padfY2 = new double[5];
  int * panPartStart2 = new int[5];
  panPartStart2[0] = 1;
  panPartStart2[1] = 3;
  panPartStart2[2] = 0;
  panPartStart2[3] = 0;
  panPartStart2[4] = 0;
  padfX2[0] = 100.32;
  padfX2[1] = 10;
  padfX2[2] = 200;
  padfX2[3] = 300;
  padfX2[4] = 500;
  padfY2[0] = 100;
  padfY2[1] = 300;
  padfY2[2] = 500;
  padfY2[3] = 123;
  padfY2[4] = 33;
  int	nEntities, nInvalidCount=0;
  double 	adfMinBound[4], adfMaxBound[4];
  SHPHandle file = SHPCreate("H:/point", SHPT_POINT);
  SHPHandle file2 = SHPCreate("H:/polilines", SHPT_ARC);
  SHPObject* obg = SHPCreateSimpleObject(SHPT_POINT,1,padfX,padfY,NULL);
  SHPWriteObject(file, -1, obg);
  padfX[0] = 200.32;
  padfY[0] = 800.32;
  obg = SHPCreateSimpleObject(SHPT_POINT,1,padfX,padfY,NULL);
  SHPObject* obg2 = SHPCreateObject(SHPT_ARC,-1,2,panPartStart2,NULL,5,padfX2,padfY2,NULL,NULL);
  SHPWriteObject(file, -1, obg);
  SHPWriteObject(file2, -1, obg2);	
  //SHPGetInfo( file, &nEntities, &nShapeType, adfMinBound, adfMaxBound );
  SHPClose(file);
  SHPClose(file2);
	
	//SHPObject* obg2 = SHPReadObject(file, 0); 
}







void dfs (int v) {
	used[v] = true;
	comp.push_back (v);
	for (size_t i=0; i<g[v].size(); ++i) {
		int to = g[v][i];
		if (! used[to])
			dfs (to);
	}
}
 
void find_comps() {
	for (int i=0; i<n; ++i)
		used[i] = false;
	for (int i=0; i<n; ++i)
		if (! used[i]) {
			comp.clear();
			dfs (i);
 			for (size_t j=0; j<comp.size(); ++j){
		}
		}
}
