#include <math.h>
#include <stdio.h>
#include "selRoi.h"
#include <iostream>
#include "cv.h"
#include "opencv2/core/core.hpp"
#include "opencv2/highgui/highgui.hpp"
#include "opencv2/calib3d/calib3d.hpp"
#include "opencv2/nonfree/features2d.hpp"
#include "opencv2/imgproc/imgproc.hpp"
#include "reconst.h"
#include "contours.h"
#include "opencv\cxcore.hpp"
#include "watershed.h"
#include "morphology2.h"
extern "C"{
	#include "shapelib-1.3.0\shapefil.h"
}

using namespace cv;
using namespace std;

Mat src1;
Mat src2;
Mat src3;

/** @function thresh_callback */


/**
 * @function main
 * @brief Main function
 */
void safeContour(char* filename, vector<vector<Point>> contour);
void createDBFdescribeObjects(char* filename);
int safeGeoPoint(char* filename,double X,double Y,double Z);
void safeInDBF(char* filename, int iShape, char* title,double X,double Y,double Z);
int getIndexForName(char* name, char* dbfFileName);
vector<vector<Point>> getContourForName(char* name, char* dbfFileName, char* shpFilename);
void setRoute(vector<char *> names, char* shapeFile, char *dbfFilewithObjects, vector<double> azimuths);
void moveAlongeTheRoute(char *dbfFileName);
void thresh_callback2(int, void* );
vector<point3D> a;

int thresh2 = 100;
int max_thresh2 = 255;
   Mat src_gray2;
int cont = 0;

RNG rng2(12345);

Mat changeContrast(Mat image, double alpha, double beta){
	namedWindow("contrast",1);
	Mat new_image = Mat::zeros(image.size(), image.type());
	 for( int y = 0; y < image.rows; y++ ){
			for( int x = 0; x < image.cols; x++ ){
				for( int c = 0; c < 3; c++ ){
					new_image.at<Vec3b>(y,x)[c] =
					saturate_cast<uchar>( alpha*( image.at<Vec3b>(y,x)[c] ) + beta );
             }
    }
    }
	 imshow("contrast",new_image);
	 waitKey(0);
	 return new_image;
}


int func(Mat src)
{
	
  /// Load source image and convert it to gray
  
  /// Convert image to gray and blur it
  cvtColor( src, src_gray2, CV_BGR2GRAY );
  blur( src_gray2, src_gray2, Size(3,3) );

  /// Create Window
  char* source_window = "Source";
  namedWindow( source_window, WINDOW_NORMAL);
  imshow( source_window, src );

  createTrackbar( " Canny thresh:", "Source", &thresh2, max_thresh2, thresh_callback2 );
  thresh_callback2( 0, 0 );

  waitKey(0);
  return(0);
}

void captureFromFile(char *fileName){
	VideoCapture cap =  VideoCapture(fileName);
	for(;;){
			Mat cameraFrame;
			cap.read(cameraFrame);
			morhphology2(cameraFrame);
			vector<vector<Point>> contour = getContour(cameraFrame,100);
			drawContours(cameraFrame, contour, -1, Scalar(0,0,0,0));
			imshow("qwe",cameraFrame);
			waitKey(0);
	}


}

/** @function thresh_callback */
void thresh_callback2(int, void* )
{
  Mat canny_output;
  vector<vector<Point> > contours;
  vector<Vec4i> hierarchy;

  /// Detect edges using canny
  Canny( src_gray2, canny_output, thresh2, thresh2*2, 3 );
  /// Find contours
 // findContours( canny_output, contours, hierarchy, CV_RETR_TREE, CV_CHAIN_APPROX_SIMPLE, Point(0, 0) );
  findContours( canny_output, contours, hierarchy, CV_RETR_LIST, CV_LINK_RUNS, Point(0, 0) );
  std::vector<std::vector<cv::Point> > contours_poly( contours.size() );
  /// Draw contours
  Mat drawing = Mat::zeros( canny_output.size(), CV_8UC3 );
  //for( int i = 0; i< contours.size(); i++ ){
  //   approxPolyDP(cv::Mat(contours[i]), contours_poly[i], 5, true );
  //}
  vector<Point> merged_contour_points;
  for (int i = 0; i < contours_poly.size(); i++) {
	 for (int j = 0; j < contours_poly[i].size(); j++) {
		 merged_contour_points.push_back(contours_poly[i][j]);
  }
	}
  std::vector<cv::Point> hull2;
  cv::convexHull(cv::Mat(merged_contour_points),hull2);
  contours.push_back(hull2);
  Scalar color = Scalar( rng2.uniform(0, 255), rng2.uniform(0,255), rng2.uniform(0,255) );
  drawContours( drawing, contours, contours.size()-1, color, 2, 8, hierarchy, 0, Point() );
	   
  /*for( int i = 0; i< contours.size(); i++ ){
   
	  
	  if (contours[i].size() >15)
	  {
       Scalar color = Scalar( rng2.uniform(0, 255), rng2.uniform(0,255), rng2.uniform(0,255) );
       drawContours( drawing, contours, i, color, 2, 8, hierarchy, 0, Point() );
	   }
  }*/
  /// Show in a window
  namedWindow( "Contours", WINDOW_NORMAL );
  imshow( "Contours", drawing );
}



void createSHPshapes(char * filename){
	 SHPHandle file = SHPCreate(filename, SHPT_ARC);
}

void createSHPgeopoints(char * filename){
	SHPCreate(filename, SHPT_POINT);
}

void createTestFiles(){
	createDBFdescribeObjects("point");
	createSHPgeopoints("point");
	//createSHPshapes("object");
	//src1 = imread("p12.jpg",1);
	//src1 =changeContrast(src1, 2,20);
	//src2 = imread("p11.jpg",1);
	//morhphology2(src2);
	//src2 =changeContrast(src2, 0.5,0);
	//src3 = imread("p13.jpg",1);
	//src3 =changeContrast(src3, 3,20);
	
	//vector<vector<Point>> contours1 = getContour(src1,20);
	//waitKey(0);
	//vector<vector<Point>> contours2 = getContour(src2, 20);
	//waitKey(0);
	
	//vector<vector<Point>> contours3 = getContour(src3, 20);
	//safeContour("object", contours1);
	safeGeoPoint("point", 30.55678,60.31215,23);
	safeInDBF("point",0,"crossroads",30.55678,60.31215,23); 
	
	//safeContour("object", contours2);
	safeGeoPoint("point", 30.55132,60.31541,20);
	safeInDBF("point",1,"firewood",30.55132,60.31541,20); 
	
	//safeContour("object", contours3);
	safeGeoPoint("point", 30.55521, 60.31584, 20);
	safeInDBF("point",2,"highway", 30.55521, 60.31584, 20); 
	
	
	safeGeoPoint("point", 30.551376, 60.314725, 20);
	safeInDBF("point",3,"tree", 30.551376, 60.314725, 20); 
	
	vector<char*> temp;
	vector<double> azimuths;
	temp.push_back("highway");
	temp.push_back("firewood");
	temp.push_back("tree");
	temp.push_back("crossroads");
	
	setRoute(temp,"route", "point",azimuths );
}



int main( int argc, char** argv )
{
	//selColor();
	finished();
	//namedWindow("contour",WINDOW_NORMAL);
	
	//mtemplate();
	//selectRoi();

	//captureFromFile("H://cv/1.mp4");
	
	//createTestFiles();
	
	//moveAlongeTheRoute("route");
	
	return 0;
	//getIndexForName("dom4", "point");
    
	
	
	//src1 = morhphology2(src1);
	//src2 = morhphology2(src2);
 
	
	
	//Moments moments1 = moments(contours1[0],false);
    //Moments moments2 = moments(contours2[0],false);
	//int Xc1 = moments1.m10/moments1.m00;
	//int Yc1 = moments1.m01/moments1.m00;
	//int Xc2 = moments2.m10/moments2.m00; 
	//int Yc2 = moments2.m01/moments2.m00;
/*	Foto foto2;
	Foto foto1;
	foto1.photo = src1;
	foto1.X = 0;
	foto1.Y = 0;
	foto1.Z = 0;
	foto1.kappa = 0;
	foto1.omega = 0;
	foto1.alpha = 0;
	foto1.focus = 0;
	foto2.photo = src2;
	foto2.X = 0;
	foto2.Y = 0;
	foto2.Z = 0;
	foto2.kappa = 0;
	foto2.omega = 0;
	foto2.alpha = 0;
	foto2.focus = 0;
	point3D point = reconst(foto1,foto2,Xc1,Yc1,Xc2,Yc2);
	*/
	return 0;

}


void safeContour(char* filename, vector<vector<Point>> contour){
	vector<Point> a = vector<Point>();
	for(int i = 0; i < contour.size(); ++i){
		for(int j = 0; j < contour[i].size(); ++j){
			a.push_back(contour[i][j]);
		}
	}
	double * padfX = new double[a.size()];
    double * padfY = new double[a.size()];
	int * panStart = new int[contour.size()];
	int * pantype = new int[contour.size()];
	int count = 0;
	for(int i = 0; i < contour.size(); ++i){
	  panStart[i] = count;
	  pantype[i] = NULL;
	  for(int j = 0; j < contour[i].size() && count < a.size(); ++j){
		//padfX[count] =  -a[count].x + 3200 - 1000;
		//padfY[count] =   a[count].y - 3200 + 1000;
		padfX[count] =   a[count].x;
		padfY[count] =   a[count].y;
		count++;
	  }
  }
	SHPHandle file = SHPOpen(filename, "r+b");
    SHPObject* obg = SHPCreateObject(SHPT_ARC,-1,contour.size(),panStart, NULL,a.size(),padfX,padfY,NULL,NULL);

	SHPWriteObject(file, -1, obg);
	SHPClose(file);
}

void createDBFdescribeObjects(char* filename){
	DBFHandle dbfFile = DBFCreate(filename);
	DBFAddField(dbfFile, "nameObject",FTString,20,0);
	DBFAddField(dbfFile, "X",FTDouble,10,7);
	DBFAddField(dbfFile, "Y",FTDouble,10,7);
	DBFAddField(dbfFile, "Z",FTDouble,1000,7);
	DBFClose(dbfFile);
}

void safeInDBF(char* filename, int iShape, char* title,double X,double Y,double Z){
	DBFHandle dbfFile = DBFOpen(filename,"r+");
	DBFWriteStringAttribute(dbfFile, iShape, 0, title);	
	DBFWriteDoubleAttribute(dbfFile, iShape, 1, X);	
	DBFWriteDoubleAttribute(dbfFile, iShape, 2, Y);	
	DBFWriteDoubleAttribute(dbfFile, iShape, 3, Z);	
	DBFClose(dbfFile);
}

int safeGeoPoint(char* filename,double X,double Y,double Z){
	SHPHandle file = SHPOpen(filename,"r+b");
	double * padfX = new double[1];
    double * padfY = new double[1];
	double * padfZ = new double[1];
	int * panPartStart = new int[1];
    panPartStart[0] = 1;
	padfX[0] = X;
    padfY[0] = Y;
	padfZ[0] = Z;
	SHPObject* obg = SHPCreateSimpleObject(SHPT_POINT,1,padfX,padfY,padfZ);
	SHPWriteObject(file, -1, obg);
	
	int* pnEntities = new int[1];

	SHPGetInfo(file, NULL,NULL,NULL,NULL);
	SHPClose(file);
	return pnEntities[0];
}

int getIndexForName(char* name, char* dbfFileName){
	DBFHandle dbfFile = DBFOpen(dbfFileName,"r+");
	int countRecords = DBFGetRecordCount( dbfFile);
	for(int i = 0; i < countRecords; i++){
		const char* temp = DBFReadStringAttribute(dbfFile, i, 0);
		if (strcmp(temp, name)==0){
			DBFClose(dbfFile);
			return i;
		}
	}
	DBFClose(dbfFile);
	return -1;
}

vector<vector<Point>> getContourForName(char* name, char* dbfFileName, char* shpFilename){
	vector<vector<Point>> res;
	int i = getIndexForName(name,dbfFileName);
	SHPHandle shapeFile = SHPOpen("object","r+");
	SHPObject* obj = SHPReadObject(shapeFile,i);
	for(int i = 0; i < obj->nParts - 1; ++i){
		vector<Point> a;
		int start = obj->panPartStart[i];
		int stop = obj->panPartStart[i+1];
		for(int j =start; j < stop; ++j){
			a.push_back(Point(obj->padfX[j],obj->padfY[j]));
		}
		res.push_back(a);
	}
	vector<Point> a;

	for(int i = obj->panPartStart[obj->nParts - 1]; i < obj->nVertices; ++i){
		a.push_back(Point(obj->padfX[i],obj->padfY[i]));
	}

	res.push_back(a);
	SHPClose(shapeFile);
	return res;
}

double* getPointForName(char*name, char* filenameDBF){
	double res[2];
	int i = getIndexForName(name, filenameDBF);
	DBFHandle dbfFile = DBFOpen(filenameDBF, "r");
	const char * q1 = DBFReadStringAttribute(dbfFile, i,1);
	res[0] = atof(q1);
	const char * q2 = DBFReadStringAttribute(dbfFile, i,2);
	res[1]= atof(q2);
	return res;
}
double getAzimuth(double x1,double y1,double x2,double y2){
	double dX =  x2 - x1;
    double dY =  y2 - y1;
	double dist = sqrt((dX*dX) + (dY*dY));
	double dXa = abs(dX);
	double beta =  acos(dXa / dist) * 180 / 3.14159265;
    double angle = 0;
	if (dX > 0){
		if (dY < 0){
    		angle = 270 + beta;
		}
		else {
    		angle = 270 - beta;
		}
	}
    else {
		if (dY < 0){
    		angle = 90 - beta;
		}
	
		else{
    	angle = 90 + beta;
	}
	}
	return angle;
}

void setRoute(vector<char *> names, char* shapeFile, char *dbfFilewithObjects, vector<double> azimuths){
	SHPHandle file = SHPCreate(shapeFile, SHPT_ARC);
	DBFHandle dbfFile = DBFCreate(shapeFile);
	DBFAddField(dbfFile, "nameObject",FTString,20,0);
	DBFAddField(dbfFile, "Rout",FTDouble,180,7);
	
	for(int i = 0; i < names.size()-1; ++i){
		double * p1 = getPointForName(names[i],dbfFilewithObjects);
		double point1[2];
		double point2[2];
		point1[0] = p1[0];
		point1[1] = p1[1];
		p1 = getPointForName(names[i+1],dbfFilewithObjects);
		point2[0] = p1[0];
		point2[1] = p1[1];
		
		double padfX[2];
		double padfY[2];
		double padfZ[2];
		int panPartStart[1];
		padfX[0] = point1[0];
		padfY[0] = point1[1];
		padfZ[0] = 1;
		padfX[1] = point2[0];
		padfY[1] = point2[1];
		padfZ[1] = 1;
		panPartStart[0] = 1;
		SHPObject* obg = SHPCreateSimpleObject(SHPT_ARC,2,padfX,padfY,NULL);
		SHPWriteObject(file, -1, obg);
		DBFWriteStringAttribute(dbfFile, i, 0, names[i]);
		double azimuth = 0;
		if (azimuths.empty())
			azimuth = getAzimuth(point1[0],point1[1], point2[0],point2[1]);
		else azimuth = azimuths[i];
		DBFWriteDoubleAttribute(dbfFile, i, 1,azimuth);	
	}
	DBFWriteStringAttribute(dbfFile, names.size()-1, 0, names[names.size()-1]);
	DBFClose(dbfFile);
	SHPClose(file);
	
}


void capture(char *fileName){
	VideoCapture cap =  VideoCapture(fileName);
	for(;;){
			Mat cameraFrame;
			cap.read(cameraFrame);
			vector<vector<Point>> contour = getContour(cameraFrame,100);
			drawContours(cameraFrame, contour, -1, Scalar(0,0,0,0));
			imshow("qwe",cameraFrame);
	}


}


void moveAlongeTheRoute(char *dbfFileName){

	DBFHandle dbfFile = DBFOpen(dbfFileName,"r+");
	int countRecords = DBFGetRecordCount( dbfFile);
	int i = 0;
	VideoCapture cap = VideoCapture(0);	
	for(int i = 0; i <= countRecords - 1; ++i){
		const char* t = DBFReadStringAttribute(dbfFile, i, 0);
	    char* name=const_cast<char*>(t); 
		vector<vector<Point>> temp1 = getContourForName(name,"point", "object");
		namedWindow("qwe",1); 
		namedWindow("route",WINDOW_NORMAL);
		Mat image =  Mat::zeros(2000,2000,CV_8UC3 );
		drawContours(image, temp1, -1, Scalar(234,234,234,234));
		imshow("route", image);
		waitKey(0);	
		while (true) {
			Mat cameraFrame;
			cap.read(cameraFrame);
			vector<vector<Point>> contour = getContour(cameraFrame,100);
			drawContours(cameraFrame, contour, -1, Scalar(0,0,0,0));
			imshow("qwe",cameraFrame);
			
			if (contour.size() == 0) continue;
			
			double match = matchShapes(temp1[0],contour[0],CV_CONTOURS_MATCH_I2, NULL);
			cout << match;
			if (match >= 0 && match < 0.15 && contour[0].size() != 0){
				waitKey(0);
				double azimuth =  DBFReadDoubleAttribute(dbfFile, i, 1);
				cout << azimuth << endl;
         		break;
			}
			if (waitKey(30) >= 0)
				break;
		}
}
	DBFClose(dbfFile);
}








