#include <math.h>
#include <stdio.h>
#include <iostream>
#include "cv.h"
#include "opencv2/objdetect/objdetect.hpp"
#include "opencv2/highgui/highgui.hpp"
#include "opencv2/imgproc/imgproc.hpp"
#include "opencv2/core/core.hpp"
#include "opencv2/highgui/highgui.hpp"
#include "opencv2/calib3d/calib3d.hpp"
#include "opencv2/nonfree/features2d.hpp"
#include "opencv2/imgproc/imgproc.hpp"
#include "reconst.h"
#include "contours.h"
#include "opencv\cxcore.hpp"
#include "watershed.h"
#include "morphology2.h"
#include "contours.h"



using namespace std;
using namespace cv;

/// Global Variables
Mat img4; Mat templ; Mat result;
const char* image_window = "Source Image";
const char* result_window = "Result window";

int match_method;
int max_Trackbar = 5;

/// Function Headers
void MatchingMethod( int, void* );

using namespace cv;
bool roi_captured = false;
Point pt1, pt2;
Mat cap_img;
bool roi_got = false;
//Callback for mousclick event, the x-y coordinate of mouse button-up and button-down 
//are stored in two points pt1, pt2.
void mouse_click(int event, int x, int y, int flags, void *param)
{

    switch(event)
    {
        case EVENT_LBUTTONDOWN:
        {
            std::cout<<"Mouse Pressed"<<std::endl;

            if(!roi_captured)
            {
                pt1.x = x;
                pt1.y = y;
            }
            else
            {
                std::cout<<"ROI Already Acquired"<<std::endl;
            }
        break;
        }
        case EVENT_LBUTTONUP:
        {
          if(!roi_captured)
        {
            Mat cl;
            std::cout<<"Mouse LBUTTON Released"<<std::endl;

            pt2.x = x;
            pt2.y = y;
            cl = cap_img.clone();
            Mat roi(cl, Rect(pt1, pt2));
            Mat prev_imgT = roi.clone();
            std::cout<<"PT1"<<pt1.x<<", "<<pt1.y<<std::endl;
            std::cout<<"PT2"<<pt2.x<<","<<pt2.y<<std::endl;
			char* str ="";
			cin >> str; 
          //  imshow("Clone",cl);

            roi_captured = true;
        }
        else
        {
            std::cout<<"ROI Already Acquired"<<std::endl;
        }
        break;  
        }

    }

}
//In main open video and wait for roi event to complete by the use.
// You capture roi in pt1 and pt2 you can use the same coordinates for processing // //subsequent frame
int selectRoi()
{
    int frame_num = 0;
    int non_decode_frame =0;
    int count = 1, idx =0;
    int frame_pos =0;
	bool roi_got;
	namedWindow("My_Win",WINDOW_NORMAL);
	roi_got = false;
    
	int i = 803;
     while(i < 920)
    {
		   
			if(!roi_captured)
            {
                            //Wait here till user select the desire ROI
				char a[26] ="H:\\cv\\123\\G0040";
				char temp[3];
				sprintf(temp, "%d", i);
				strcat (temp, ".jpg");
				strcat (a,temp);
				cap_img = imread(a);
				imshow("My_Win", cap_img);
				getContour(cap_img, 100);
				//setMouseCallback("My_Win", mouse_click, 0);
                waitKey(0);
				i++;
            }
            else
            {
                std::cout<<"Got ROI disp prev and curr image"<<std::endl;
                std::cout<<"PT1"<<pt1.x<<" "<<pt1.y<<std::endl;
                std::cout<<"PT2"<<pt2.x<<" "<<pt2.y<<std::endl;

                Mat curr_img_t1;
                Mat roi2(cap_img,Rect(pt1, pt2));
                Mat curr_imgT = roi2.clone();
                //cvtColor(curr_imgT, curr_img_t1, CV_RGB2GRAY);
				char a[26] ="H:\\cv\\321\\G0040";
				char temp[3];
				sprintf(temp, "%d", i);
				strcat (temp, ".jpg");
				strcat (a,temp);
				imwrite(a,curr_imgT);
            //        imshow("curr_img", curr_img_t1);

            // Do remaining processing here on capture roi for every frame
                              // waitKey(0);
							   roi_captured = false;
							   i++;
                       }
                  }
	 return 0;
}


/**
 * @file MatchTemplate_Demo.cpp
 * @brief Sample code to use the function MatchTemplate
 * @author OpenCV team
 */



/**
 * @function main
 */
int mtemplate()
{

  /// Load image and template
  img4 = imread("H:\\cv\\123\\G0040907.jpg"  );
  templ = imread("H:\\road" );
  
  /// Create windows
  namedWindow( image_window, WINDOW_NORMAL );
  namedWindow( result_window, WINDOW_NORMAL );

  /// Create Trackbar
  const char* trackbar_label = "Method: \n 0: SQDIFF \n 1: SQDIFF NORMED \n 2: TM CCORR \n 3: TM CCORR NORMED \n 4: TM COEFF \n 5: TM COEFF NORMED";
  createTrackbar( trackbar_label, image_window, &match_method, max_Trackbar, MatchingMethod );

  MatchingMethod( 0, 0 );

  waitKey(0);
	
  return 0;
}

/**
 * @function MatchingMethod
 * @brief Trackbar callback
 */
void MatchingMethod( int, void* )
{
  /// Source image to display
  Mat img_display;
  img4.copyTo( img_display );

  /// Create the result matrix
  int result_cols = abs( img4.cols - templ.cols + 1);
  int result_rows =abs( img4.rows - templ.rows + 1);

  result.create( result_cols, result_rows, CV_32FC1 );

  /// Do the Matching and Normalize
  matchTemplate( img4, templ, result, match_method );
  normalize( result, result, 0, 1, NORM_MINMAX, -1, Mat() );

  /// Localizing the best match with minMaxLoc
  double minVal; double maxVal; Point minLoc; Point maxLoc;
  Point matchLoc;

  minMaxLoc( result, &minVal, &maxVal, &minLoc, &maxLoc, Mat() );

 int stop = 0;;
  /// For SQDIFF and SQDIFF_NORMED, the best matches are lower values. For all the other methods, the higher the better
  if( match_method  == TM_SQDIFF || match_method == TM_SQDIFF_NORMED )
    { matchLoc = minLoc;
      int stop =0; }
  else
    { matchLoc = maxLoc;
      int stop =0;}

  /// Show me what you got
  Mat roi2(img_display,Rect(Point(matchLoc.x,matchLoc.y),Point(matchLoc.x + templ.cols,matchLoc.y + templ.rows)));
  vector<vector<Point>> contour1 = getContour(templ,100);
  vector<vector<Point>> contour2 = getContour(roi2,100);
  double match = matchShapes(contour1[0],contour2[0],CV_CONTOURS_MATCH_I2, NULL);
  rectangle( img_display, matchLoc, Point( matchLoc.x + templ.cols , matchLoc.y + templ.rows ), Scalar::all(0), 2, 8, 0 );
  rectangle( result, matchLoc, Point( matchLoc.x + templ.cols , matchLoc.y + templ.rows ), Scalar::all(0), 2, 8, 0 );

  imshow( image_window, img_display );
  imshow( result_window, result );
  return;
}

 String face_cascade_name = "shape.xml";
 CascadeClassifier face_cascade;
 string window_name = "Capture - Face detection";
 RNG rng3(12345);

void detectAndDisplay( Mat frame )
{
  std::vector<Rect> faces;
  Mat frame_gray;

  cvtColor( frame, frame_gray, CV_BGR2GRAY );
  equalizeHist( frame_gray, frame_gray );

  //-- Detect faces
  face_cascade.detectMultiScale( frame_gray, faces, 1.1, 2, 0|CV_HAAR_SCALE_IMAGE, Size(30, 30) );

  for( size_t i = 0; i < faces.size(); i++ )
  {
    Point center( faces[i].x + faces[i].width*0.5, faces[i].y + faces[i].height*0.5 );
    ellipse( frame, center, Size(faces[i].width, faces[i].height), 0, 0, 360, Scalar( 255, 0, 255 ), 4, 8, 0 );
    Mat faceROI = frame_gray(faces[i]);
  }
  //-- Show what you got
  imshow( window_name, frame );
 }

int finished()
 {
   Mat frame =imread("shape.jpg");
   namedWindow(window_name, WINDOW_NORMAL);
   //-- 1. Load the cascades
   resize(frame, frame, Size(frame.size().width /12, frame.size().height/12),1);
		
   if( !face_cascade.load( face_cascade_name ) ){ printf("--(!)Error loading\n"); return -1; };
   detectAndDisplay(frame);
   waitKey(0);
   //-- 2. Read the video stream
   return 0;
 }


//
//   
// Rmin, Rmax, Gmin, Gmax, Bmin, Bmax
//      
//
// robocraft.ru
//



int selColor()
{
        //     
        char* filename ="w3.jpg";
        //  
        Mat img = imread(filename,1);
		Mat rgb1 = Mat(img.size(), IPL_DEPTH_8U, 3); 
		Mat r_plane1 = Mat(img.size(), IPL_DEPTH_8U, 1); 
		Mat g_plane1 = Mat(img.size(), IPL_DEPTH_8U, 1); 
		Mat b_plane1 = Mat(img.size(), IPL_DEPTH_8U, 1); 
		Mat r_range1 = Mat(img.size(), IPL_DEPTH_8U,1);
		Mat b_range1 = Mat(img.size(), IPL_DEPTH_8U,1);
		Mat g_range1 = Mat(img.size(), IPL_DEPTH_8U,1);
		img.copyTo(rgb1);
		Mat channels[3];
		split(rgb1,channels);
		channels[0].copyTo(b_plane1);
		channels[1].copyTo(g_plane1);
		channels[2].copyTo(r_plane1);
		inRange(r_plane1, Scalar(225), Scalar(256), r_range1);
		//resize(r_range1, r_range1, Size(r_range1.size().width /12, r_range1.size().height/12),1);
		medianBlur(r_range1, r_range1, 5);
		namedWindow("qwe", WINDOW_NORMAL);
		imshow("qwe", r_range1);
		imwrite("square.jpg", r_range1);
		waitKey(0);
		return 0;
}